#include <Servo.h>
#include <IRremote.h>

int RECV_PIN = 11; // Пин подключения нашего инфокрасного приёмника

Servo s1, s2, s3, s4; //  4-е сервы

boolean btnStates[17], changed = false;

/*
btnStates[0] - движение вперёд  FD807F  
btnStates[1] - движение назад  FD906F  
btnStates[2] - движение вправо  FD609F  
btnStates[3] - движение влево    FD20DF  
btnStates[4] - включение питания серв FD00FF  
btnStates[5] - разжим клешни FD30CF  
btnStates[6] - стоп FDA857  
btnStates[7] - зажим клешни  FDA857  
btnStates[8] - движение вправо нижней сервы 
btnStates[9] - движение влево нижней сервы
btnStates[10] - движение вверх сервы подн. руку
btnStates[11] - движение вниз  сервы подн. руку
btnStates[12] - движение вниз  локтя
btnStates[13] - движение вверх  локтя
btnStates[14] - в исходное положение
*/

/*
0 - FD30CF;
1 - FD08F7;
2 - FD8877;
3 - FD48B7;
4 - FD28D7;
5 - FDA857;
6 - FD6897;
7 - FD18E7;
8 - FD9867;
9 - FD58A7;
FUNC/STOP - FD40BF;
*/

IRrecv irrecv(RECV_PIN);

int i, pos, n, l, y = 0;

decode_results results;

void moving(int sp0, int sp1, boolean mv0, boolean mv1, boolean mv2, boolean mv3) {
  analogWrite(12, sp0);
  analogWrite(10, sp1); 
  digitalWrite(8, mv0);
  digitalWrite(2, mv1);
  digitalWrite(7, mv2);
  digitalWrite(4, mv3);
}

void stand() {
  s1.write(90); //нижняя серва 
  s2.write(20); // локоть
  s3.write(180); //клешня
  s4.write(90); //подн. руку
}

void detached() { // отключаем сервы для того, чтобы не тратить заряд Li-Po батареи
  s1.detach();
  s2.detach();
  s3.detach();
  s4.detach();
}

void attaching() { // подключаем сервы
  s1.attach(3); 
  s2.attach(5);
  s3.attach(6);
  s4.attach(9);
}



void setup() {
  i = 90;
  n = 90;
  l = 20;
  s1.attach(3); 
  s2.attach(5); 
  s3.attach(6);
  s4.attach(9); 
  irrecv.enableIRIn(); 
}

void loop() {
  if (irrecv.decode(&results)) { // Приём  значений с пульта
    delay(50);
    if (results.value == 0xFD00FF && results.value != 0xFFFFFFFF) {
      btnStates[4] = true;
    }
    if (results.value == 0xFD807F && results.value != 0xFFFFFFFF) {
      btnStates[0] = true;
      for (y = 1; y <= 15; y++) {
        btnStates[y] = false;
      } 
    }else btnStates[0] = false;
    if (results.value == 0xFD30CF && results.value != 0xFFFFFFFF) {
        for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
        }
        btnStates[4] = true;
        btnStates[5] = true;
    }else btnStates[5] = false;
    if (results.value == 0xFD40BF && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
      }
      btnStates[4] = true;
      btnStates[14] = true;
    }else btnStates[14] = false;
    if (results.value == 0xFD28D7 && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
        }btnStates[4] = true;
        btnStates[8] = true;
    }else btnStates[8] = false;
    if (results.value == 0xFD6897 && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
      }
      btnStates[4] = true;
      btnStates[9] = true;
    }else btnStates[9] = false;
    if (results.value == 0xFD8877 && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
        }
      btnStates[4] = true;
      btnStates[10] = true;
    }else btnStates[10] = false;
    if (results.value == 0xFD9867 && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
      }
      btnStates[4] = true;
      btnStates[11] = true;
    }else btnStates[11] = false;
    if (results.value == 0xFD50AF && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
        }
        btnStates[4] = true;
        btnStates[12] = true;
    }else btnStates[12] = false;
    if (results.value == 0xFD10EF && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
        btnStates[y] = false;
        }btnStates[4] = true;
        btnStates[13] = true;
    }else btnStates[13] = false;
    if (results.value == 0xFD906F && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
      }
        btnStates[1] = true;
    }else btnStates[1] = false;
    if (results.value == 0xFD609F && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
        btnStates[y] = false;
      }
        btnStates[2] = true;
    }else btnStates[2] = false;
    if (results.value == 0xFD20DF && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
        btnStates[y] = false;
      }
      btnStates[3] = true;
    }else btnStates[3] = false;
    if (results.value == 0xFDA05F && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
        }
        btnStates[6] = true;
    }else btnStates[6] = false;
    if (results.value == 0xFDA857 && results.value != 0xFFFFFFFF) {
      for (y = 0; y <= 14; y++) {
          btnStates[y] = false;
        }
        btnStates[4] = true;
        btnStates[7] = true;
    }else btnStates[7] = false;
    if (btnStates[4]) {
      attaching();
    }else detached();
    if (btnStates[0]) { // Движение вперёд
      moving(255, 255, HIGH, HIGH, LOW, LOW);
    }
    if (btnStates[1]) { // Движение назад
      moving(255, 255, LOW, LOW, HIGH, HIGH);
    }
    if (btnStates[2]) { // Движение вправо
      moving(120, 255, LOW, HIGH, HIGH, LOW);
    }
    if (btnStates[3]) { // Движение влево
      moving(255, 120, HIGH, LOW, LOW, HIGH);
    }
    if (btnStates[6]) { //  стоп
      moving(0, 0, LOW, LOW, LOW, LOW);
    }
    if (btnStates[7]) { // Движение клешни
      for(pos = 180; pos >= 140; pos--) {                                  
        s3.write(pos);          
        delay(10);                      
      }changed = true;
    }
    if (btnStates[8]) {
      i+=5;
      changed = true;
    }
    if (btnStates[5]) {
      for(pos = 140; pos <= 180; pos++) {                                  
        s3.write(pos);          
        delay(10);                      
      }changed = true;
    }
    if (btnStates[14]) {
      stand();
      i = 90;
      n = 90;
      l = 20;
      changed = false;
    }
    if (btnStates[9]) {
      i-=5;
      changed = true;
    }
    int var = i;
    var = map(var, 0, 180, 0, 180);
    s1.write(var);
    if (btnStates[10]) {
      n-=20;
      changed = true;
    }
    if (btnStates[11]) {
      n+=20;
      changed = true;
    }
    int var1 = n;
    var1 = map(var1, 0, 180, 0, 180);
    s4.write(var1);
    if (btnStates[12]) {
      l-=20;
      changed = true;
    }
    if (btnStates[13]) {
      l+=20;
      changed = true;
    }
    int var2 = l;
    var2 = map(var2, 0, 180, 0, 180);
    s2.write(var2);
    delay(50);
    irrecv.resume(); 
  }else if (changed == false) {
    stand();
  }
}
